
/*
  GoodFields 09_lcd
  LCD
  Gestion du temps
  Compactage des sorties série (intégration d'une bibliothèque : Streaming)
  GRAFCET
  TEMPORISATION basique
  FRONT MONTANT/DESCENDANT
  
MMaintenant que l'on a l'heure, on pourrait faire une horloge avec l'écran LCD, non ?
Ajouter la librairie LiquidCrystal.h :
#include <LiquidCrystal.h>
*/
 
//**********************************************************
// BIBLIOTHEQUES
// incluses dans le package Arduino de base
#include <LiquidCrystal.h>  // LCD

// ajoutées
#include <Streaming.h>
#include <Time.h>

//**********************************************************
// DECLARATIONS
// LCD initialize the library with the numbers of the interface pins
/* Câblage du LCD
 * LCD pin 1 to GND
 * LCD pin 2 to VCC 5V
 * LCD pin 3 : contraste sur le point milieu d'un potentiomètre de 10K entre le GND et le VCC (réglé très près de la masse)
 * LCD pin 4 RS to digital pin 4
 * LCD pin 5 RW to GND
 * LCD pin 6 Enable pin to digital pin 2
 * LCD pin 11 D4 pin to digital pin 6
 * LCD pin 12 D5 pin to digital pin 7
 * LCD pin 13 D6 pin to digital pin 8
 * LCD pin 14 D7 pin to digital pin 9
*/
//  LiquidCrystal lcd(RS, Enable,  D4, D5, D6, D7)
  LiquidCrystal lcd(4, 2, 6, 7, 8, 9);

// entrées-sorties
int led_a = 13;
// temporisations
int tempo_a,tempo_b;
// vitesse de clignotement : maintenant en millisecondes
int tempo_a_reset=1000;
int tempo_b_reset=700;
// gestion du temps
int previousSecond;      // secondes de l'horloge
int top_dixieme=false;   // top pour traitements au 1/10 seconde dans le P/P
int top_seconde=false;   // top pour traitements à la seconde dans le P/P
int top_minute=false;   // top pour traitements à la minute dans le P/P
unsigned long previousMillis, previousDecis;
// GRAFCETS
int grafcet_a,grafcet_b;

// calcul de vitesse ...
unsigned long tours_ps,tours;

//**********************************************************
// INITIALISATIONS
void setup() {
// mise à l'heure
  setTime(12,15,00,25,12,13); // 12h15 le 25 déc 2013 setupArduinoTime(2013,25,21,12,15,00));

// initialize the digital pins
  pinMode(led_a, OUTPUT);     

// définition taille du LCD :
  lcd.begin(16, 2);

// ligne série (pour traces)
  Serial.begin(9600);  // ou 9600 selon votre port COM
  Serial << "Serial ok" << endl;

// AFFICHAGE sur LCD
  lcd.setCursor(0, 0);  lcd << "Serial OK";     // 1ere ligne
  lcd.setCursor(0, 1);  lcd << "GoodFields";    // 2eme ligne
  delay(1000);        // pour profiter du LCD au démarrage
  lcd.clear();    // Effacement général LCD
  
// on arme les grafcets
  grafcet_a = 1;
  grafcet_b = 1;
}
//**********************************************************
// PROGRAMME PRINCIPAL
void loop() {

// tours par seconde
  tours++;
  
// gestion du temps
  ger_top_centieme ();
  
// opérations à chaque dixième de seconde
  if (top_dixieme) {
    lcd.setCursor(0, 1);  lcd << "b=" << grafcet_b <<  " a=" << grafcet_a ;    // 2eme ligne lcd
    top_dixieme = false;
  }
  
// opérations à chaque seconde
  if (top_seconde) {
    top_seconde = false;

    tours_ps=tours; tours=0;
    lcd.setCursor(8, 1);  lcd << tours_ps << "t/s  ";    // 2eme ligne lcd

// horloge
    horodatage_serial(); Serial << " top_seconde" << endl;
    lcd.setCursor(0, 0);
    if (second()%10 > 7) {
      lcd << "XXX " << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year();
    } else {
      lcd << "    " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "    ";
    }
// idéalement, XXX devarit être remplacé par {"Lun","Mar","Mer","Jeu","Ven","Sam","Dim"} (au boulot !)
    
// heart-beat chaque seconde   
//    if (lamp_tempo == 0 ) lamp_tempo = 20;  // ms
    }

//--------------------------------
// GRAFCET A
switch (grafcet_a) {

  case 1:
  if ( tempo_a == 0 ) {        // si la tempo est terminée,
    digitalWrite(led_a, HIGH);   // on allume la LED
    tempo_a = tempo_a_reset;             // on arme la tempo
    grafcet_a++;               // et on passe à l'étape suivante
  }
  break;      // cette instruction vous fait sauter à la fin du "switch"
  // sinon, on continue, et cela fait perdre du temps, et il peut arriver que d'autre "case" fonctionnent ! 

  case 2:
  if ( tempo_a == 0 ) {
    digitalWrite(led_a, LOW);    // turn the LED off by making the voltage LOW
    tempo_a = tempo_a_reset;             // on arme la tempo
    grafcet_a=1;               // on reboucle
  }    
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
      grafcet_a = 0; // on arrête
  break;
}      // fin du "switch"
// FIN GRAFCET A
//--------------------------------
// GRAFCET B
switch (grafcet_b) {

  case 1:
  if ( tempo_b == 0 ) {        // si la tempo est terminée,
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a << endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b++;               // et on passe à l'étape suivante
  }
  break;      // cette instruction vous fait sauter à la fin du "switch"

  case 2:
  if ( tempo_b == 0 ) {
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a << endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b=1;               // on reboucle
  }    
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
      grafcet_b = 0; // on arrête
  break;
}      // fin du "switch"
// FIN GRAFCET B
//--------------------------------
}
// ************************************************************************************************
// SOUS-PROGRAMMES
// ************************************************************************************************
// Programme au -ieme de seconde
// gestion des temporisations
// NB : le débordement du compteur en (unsigned long) a lieu tous les 50 jours environ ...
// mais ne pose pas de problème sur le calcul du 'delta' qui tourne toujours
void ger_top_centieme (){
  unsigned long delta;
  unsigned long currentMillis = millis();

// Centième de secondes
   delta = currentMillis - previousMillis;
   if (delta >= 10) {
// save the last time you come here
    previousMillis = currentMillis;   

// scrutation du clavier toutes les 10ms
//    ger_scrute_clavier();

// allumage temporisé led clavier
//    if (lamp_tempo >= delta) { lamp_tempo -= delta; digitalWrite(lamp, HIGH); } else { lamp_tempo = 0; digitalWrite(lamp, LOW); }

// temporisations diverses
//    if (fonction_tempo >= delta) { fonction_tempo -= delta; } else { fonction_tempo = 0; }
// gestion des TEMPORISATIONS
    if (tempo_a >= delta ) { tempo_a -= delta; } else { tempo_a = 0; }
    if (tempo_b >= delta ) { tempo_b -= delta; } else { tempo_b = 0; }
   }

// Dixième de seconde
   delta = currentMillis - previousDecis;
   if (delta >= 100) {
    previousDecis = currentMillis;   
    top_dixieme = true;
    
// tops seconde et minute pour traitements dans le main
    if (second() != previousSecond) {
      previousSecond = second();
      top_seconde = true;
      if (previousSecond == 0) top_minute=true;
    }
  }
  return;
}
// ************************************************************************************************
// affichage horloge complete sur la sortie serie, sans fin de ligne
void horodatage_serial() {
// digital clock display of the time
//  Serial << day() << "/" << month() << "/" << year() << " " << hour() << printDigits(minute()) << printDigits(second()) << endl; 
  Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second();
//
// décomposition de ((day()<10)?"0":"")
// SI (day()<10)   ALORS ?   ON_PRENDS"0"   SINON:   ON_PRENDS""
// ce qui fait que si day()==6 par exemple, on obtient "06"
// et si day()==12 par exemple, on obtient "12"
}
// ************************************************************************************************
/*
// Transforme la date et l'heure "lisible" en format UNIX pour mise à l'heure et date
time_t setupArduinoTime(int y,int m, int j, int h, int mi, int se) {
  tmElements_t tm;
  tm.Year = y-1970;
  tm.Month = m;
  tm.Day = j;
  tm.Hour = h;
  tm.Minute = mi;
  tm.Second = se;
  time_t time = makeTime(tm);
  return time;
}
//+ voici le s/p original qui provient d'une bibliothèque pour GPS :
time_t gpsTimeToArduinoTime(){
// returns time_t from gps date and time with the given offset hours
  tmElements_t tm;
  int year;
  gps.crack_datetime(&year, &tm.Month, &tm.Day, &tm.Hour, &tm.Minute, &tm.Second, NULL, NULL);
  time_t time = makeTime(tm);
  return time + (offset * SECS_PER_HOUR);
}
*/
// ************************************************************************************************
#define mode_horloge 0
#define mode_frequence 1
#define mode_selfmetre 2 
#define mode_capacimetre 3 
#define mode_voltmetre 4
#define mode_gbf 5
#define mode_pwm 6 
#define mode_servo 7
#define mode_accordeur 8
#define mode_barometre 9 
#define mode_thermique 10
#define mode_reveil 11
#define mode_cafe


/* FIL ROUGE
 - horloge basique
 - fréquencemètre (8 Mhz à priori, c'est facile le selfmètre capacimètre en est un)
 - un selfmètre capacimètre (c'est l'idée de départ) ???
 - un quadri-voltmètre 20 Volts, ampèremètre éventuel (détecteur à faire, mais je connais l'astuce) ???
 - un GBF (ce que peut faire l'Arduino, sans doute jusque vers 30 kHz) ???
 - mais aussi générateur de signal pour tester des servo moteurs de télécommande ???
 - et encore générateur de commande PWM ???
 - un accordeur de guitare ou autre bombarde (quand j'aurais connecté un HP) ???
 - une alimentation 5V et 12 V pour bidouiller 
 - un baro-thermomètre à base de BMP085 (bus I2C sur A4+A5) ???
 - un appareil de mesure de capacité isolante d'un mur (avec 3 capteurs DS1820 bus 1 fil sur A5) ???
 - horloge réveil temporisation ( synchro avec horloge temps réel DS1307 ou horloge radio DFM77 ??? )
 - pas le café, quoi que ... 
*/

